<template>
  <div>
    <h2>Edit emails</h2>
    <el-row>
      <el-col :sm="{span: 24, offset: 0}" :md="{span: 18, offset: 3}" :lg="{span: 14, offset: 5}">
        <el-form ref="form_email" :model="email" status-icon :inline="true">
          <el-form-item label="Email" prop="email" :error="errors.email">
            <el-input v-model="email.email"></el-input>
          </el-form-item>

          <el-form-item prop="primary" :error="errors.primary">
            <el-switch v-model="email.primary" active-text="Primary"></el-switch>
          </el-form-item>

          <el-form-item>
            <el-button type="primary" @click="submitForm()">
              Add email
            </el-button>
          </el-form-item>
        </el-form>
      </el-col>
    </el-row>

    <el-row>
      <el-col>
        <el-table :data="emails" style="width: 100%">
          <el-table-column prop="email" label="Email"></el-table-column>
          <el-table-column prop="verified" label="Verified">
            <template slot-scope="scope">
              <font-awesome-icon v-if="scope.row.verified" :icon="icon('check')" />
              <el-button v-if="!scope.row.verified" size="mini" @click="resendVerification(scope.$index, scope.row)">Resend verification</el-button>
            </template>
          </el-table-column>
          <el-table-column prop="primary" label="Primary">
            <template slot-scope="scope">
              <el-button v-if="!scope.row.primary" type="primary" size="mini" @click="setPrimary(scope.$index, scope.row)">Set primary</el-button>
              <font-awesome-icon v-if="scope.row.primary" :icon="icon('check')" />
            </template>
          </el-table-column>
          <el-table-column label="Actions">
            <template slot-scope="scope">
              <el-button type="danger" size="mini" @click="deleteEmail(scope.$index, scope.row)">Delete</el-button>
            </template>
          </el-table-column>
        </el-table>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import gql from 'graphql-tag'
import FontAwesomeIcon from '@fortawesome/vue-fontawesome'
import faCheck from '@fortawesome/fontawesome-free-solid/faCheck'

export default {
  components: { FontAwesomeIcon },

  apollo: {
    emails: {
      query: gql`{ currentUser { emails { id email verified primary } } }`,
      update({ currentUser: { emails } }) { return  emails }
    }
  },

  data() {
    return {
      emails: [],
      email: { email: '', primary: false },
      errors: { email: '', primary: '' }
    }
  },

  methods: {
    icon(name) {
      switch(name){
        case 'check':
        return faCheck
      }
    },
    submitForm() {
      this.$apollo.mutate({
        mutation: gql`mutation ($email: EmailInput!) {
          createEmail(email: $email) {
            success
            message
            errors { field message }
          }
        }`,
        variables: {
          email: this.$refs['form_email'].model
        },
        update: (store, { data: { createEmail }}) => {
          if(createEmail.success) {
            this.$message.success('Email added successfully')
            this.$apollo.queries.emails.refetch()
          }
          else {
            this.$message.error('Failed to add email')
            createEmail.errors.forEach(error => { this.$data.errors[error.field] = error.message })
          }
        }
      })
    },
    resendVerification(index, row) {
      this.$apollo.mutate({
        mutation: gql`mutation ($email: EmailInput!) {
          updateEmail(email: $email) {
            success
            message
            errors { field message }
          }
        }`,
        variables: { email: { id: row.id, resendVerification: true } },
        update: (store, { data: { updateEmail }}) => {
          if(updateEmail.success) {
            this.$message.success('Email verification sended successfully')
          }
          else {
            this.$message.error('Failed to send email verification')
            updateEmail.errors.forEach(error => { this.$data.errors[error.field] = error.message })
          }
        }
      })
    },
    setPrimary(index, row) {
      this.$confirm('Are you sure you want to set this email as primary?', 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(() => {
        this.$apollo.mutate({
          mutation: gql`mutation ($email: EmailInput!) {
            updateEmail(email: $email) {
              success
              message
              errors { field message }
            }
          }`,
          variables: { email: { id: row.id, primary: true } },
          update: (store, { data: { updateEmail }}) => {
            if(updateEmail.success) {
              this.$message.success('Email updated successfully')
              this.$apollo.queries.emails.refetch()
            }
            else {
              this.$message.error('Failed to update email')
              updateEmail.errors.forEach(error => { this.$data.errors[error.field] = error.message })
            }
          }
        })
      })
    },
    deleteEmail(index, row) {
      this.$confirm('Are you sure you want to delete this email?', 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(() => {
        this.$apollo.mutate({
          mutation: gql`mutation ($email: EmailInput!) {
            deleteEmail(email: $email) {
              success
              message
              errors { field message }
            }
          }`,
          variables: { email: { id: row.id } },
          update: (store, { data: { deleteEmail }}) => {
            if(deleteEmail.success) {
              this.$message({ type: 'success', message: 'Email deleted successfully' })
              this.$apollo.queries.emails.refetch()
            }
            else
              this.$message.error('Failed to update email')
          }
        })
      })
    }
  }
}
</script>
